//CreerUnCadre_301f.js
// 14.02.11 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Pour crer un cadre en dupliquant un objet

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// une rfrence au document
var curDoc = app.documents[0];

// mmoriser la version (pour nommer les objets temporairement, 
// selon la version il faut utiliser 'name' ou 'label')
var versNum = app.version[0];

// tester la slection
var curSel = app.selection;
var nFrames = curSel.length;
if (nFrames == 0) {
	alert ("Il faut slectionner un objet.", "Stop");
	exit();
}
else if (nFrames > 1) {
	alert ("Ne slectionner qu'un objet.", "Stop");
	exit();
}

if ((app.locale)*1 == 1279477362) { // un InDesign franais
	// dterminer l'appellation de "Noir"
	var blackCol = "Noir";
	// dfinir "Aucun" ou "Sans", selon la version
	var noColor = "[Sans]";
	var rgColor = "[Reprage]";
	if (versNum == 4) {
		noColor = "[Aucun]";
	}
}
else if ((app.locale)*1 == 1279477613) { // un InDesign allemand
	var blackCol = "Schwarz";
	var noColor = "[Ohne]";
	var rgColor = "[Passermarken]";
	if (versNum == 4) {
		noColor = "[Keine]";
		rgColor = "[Passkreuze]";
	}
}
else if ((app.locale)*1 == 1279477102 || (app.locale)*1 == 1279477097) { // un InDesign anglais
	var blackCol = "Black";
	var noColor = "[None]";
	var rgColor = "[Registration]";
}
else {
	var blackCol = "Noir";
	var noColor = "[Sans]";
	var rgColor = "[Reprage]";
	if (app.version[0] == 4) {
		noColor = "[Aucun]";
		rgColor = "[Reprage]";
	}
}
dontChange = "Ne pas modifier";

// mmoriser l'angle de rotation de l'objet
var curAngle = curSel[0].rotationAngle;

// appeler la fonction pour lire les rglages mmoriss
var allPrefs = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var frmW = prefVal[0]*1;
	var frmH = prefVal[1]*1;
	var dVal = prefVal[2]*1;
	var rVal = prefVal[3]*1;
	var elWd = prefVal[4];
	if (elWd == "true") {
		ck01 = true;
	}
	else {
		ck01 = false;
	}
	var grFr = prefVal[5];
	if (grFr == "true") {
		ck02 = true;
	}
	else {
		ck02 = false;
	}
	var bName = prefVal[6];
	if (bName == "Black") { bName = "[" + blackCol + "]"; }
	else if (bName == "Paper") { bName = "[Papier]"; }
	else if (bName == "Registration") { bName = rgColor; }
	else if (bName == "None") { bName = noColor; }
	var bgrT  = prefVal[7]*1;
	var sName = prefVal[8];
	if (sName == "Black") { sName = "[" + blackCol + "]"; }
	else if (sName == "Paper") { sName = "[Papier]"; }
	else if (sName == "Registration") { sName = rgColor; }
	else if (sName == "None") { sName = noColor; }
	var strT = prefVal[9]*1;
	var strW = prefVal[10]*1;
	var alig = prefVal[11];
	var rb01 = 1;
	var rb02 = 0;
	var rb03 = 0;
	if (alig == "1") {
		rb01 = 0;
		rb02 = 1;
	}
	else if (alig == "2") {
		rb01 = 0;
		rb03 = 1;
	}
	var rDec = prefVal[12]*1;
	var rb04 = rb05 = rb06 = rb07 = rb08 = rb09 = rb10 = rb11 = 0;
	if      (rDec == 0) { rb04 = 1; }
	else if (rDec == 1) { rb05 = 1; }
	else if (rDec == 2) { rb06 = 1; }
	else if (rDec == 3) { rb07 = 1; }
	else if (rDec == 4) { rb08 = 1; }
	else if (rDec == 5) { rb09 = 1; }
	else if (rDec == 6) { rb10 = 1; }
	else if (rDec == 7) { rb11 = 1; }
}
else {
	// si le fichier des prfrences ne peut pas tre trouv 
	// on utilise les valeurs suivantes
	var frmW =   45;
	var frmH =   45;
	var dVal =    0;
	var rVal =    0;
	var ck01 = false;
	var ck02 = true;
	var bgrT =  100;
	var strT =  100;
	var strW =  0.5;
	var rb01 =    0;
	var rb02 =    1;
	var rb03 =    0;
	var rb04 =    1;
	var rb05 =    0;
	var rb06 =    0;
	var rb07 =    0;
	var rb08 =    0;
	var rb09 =    0;
	var rb10 =    0;
	var rb11 =    0;
	var bName = dontChange;
	var sName = dontChange;
}

// appeler les fonctions pour prparer les listes des couleurs
var bgrColor = getBgrColorList(bName);
var bgrCol   = bgrColor[0];
var bInd     = bgrColor[1];
var strColor = getStrColorList(sName);
var strCol   = strColor[0];
var sInd     = strColor[1];

// mmoriser les units de mesure
// modifier  "millimtres" si ncessaire (2053991795 = Millimeter)
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
vM = curDoc.viewPreferences.verticalMeasurementUnits;
if (hM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
}
if (vM != 2053991795) {
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
}

// slectionner le point de rfrence au milieu
var trp = app.layoutWindows[0].transformReferencePoint;
if (trp != 1095656308) {
	app.layoutWindows[0].transformReferencePoint = 1095656308;
}

// mettre le poinz zro  zro/zro
var zP = curDoc.zeroPoint; 
if (zP != [0,0]) { 
	curDoc.zeroPoint = [0,0]; 
}

// appeler la fonction qui montre le dialogue
var anArray = displayDialog(frmW, frmH, dVal, rVal, ck01, ck02, bInd, bgrT, sInd, strT, strW, 
rb01, rb02, rb03, rb04, rb05, rb06, rb07, rb08, rb09, rb10, rb11);
frmW   = anArray[0];
frmH   = anArray[1];
dVal   = anArray[2];
rVal   = anArray[3];
elWd   = anArray[4];
grFr   = anArray[5];
bColor = anArray[6];
bgrT   = anArray[7];
sColor = anArray[8];
strT   = anArray[9];
strW   = anArray[10];
strA   = anArray[11];
rDec   = anArray[12];
noRota = false;
if (rDec      == 0) { // les pointes vers l'intrieur
	topLineRot  =    0 + curAngle;
	rgtLineRot  =  -90 + curAngle;
	botLineRot  = -180 + curAngle;
	lftLineRot  = -270 + curAngle;
}
else if (rDec == 1) { // les pointes vers l'extrieur
	topLineRot  = -180 + curAngle;
	rgtLineRot  = -270 + curAngle;
	botLineRot  =    0 + curAngle;
	lftLineRot  =  -90 + curAngle;
}
else if (rDec == 2) { // en carousel vers la gauche
	topLineRot  =  -90 + curAngle;
	rgtLineRot  = -180 + curAngle;
	botLineRot  = -270 + curAngle;
	lftLineRot  =    0 + curAngle;
}
else if (rDec == 3) { // en carousel vers la droite
	topLineRot  = -270 + curAngle;
	rgtLineRot  =    0 + curAngle;
	botLineRot  =  -90 + curAngle;
	lftLineRot  = -180 + curAngle;
}
else if (rDec == 4) { // les pointes vers le bas
	topLineRot  =    0 + curAngle;
	rgtLineRot  =    0 + curAngle;
	botLineRot  =    0 + curAngle;
	lftLineRot  =    0 + curAngle;
	noRota = true;
}
else if (rDec == 5) { // les pointes vers la gauche
	topLineRot  =  -90 + curAngle;
	rgtLineRot  =  -90 + curAngle;
	botLineRot  =  -90 + curAngle;
	lftLineRot  =  -90 + curAngle;
}
else if (rDec == 6) {  // les pointes vers le haut
	topLineRot  = -180 + curAngle;
	rgtLineRot  = -180 + curAngle;
	botLineRot  = -180 + curAngle;
	lftLineRot  = -180 + curAngle;
	noRota = true;
}
else if (rDec == 7) { // les pointes vers la droite
	topLineRot  = -270 + curAngle;
	rgtLineRot  = -270 + curAngle;
	botLineRot  = -270 + curAngle;
	lftLineRot  = -270 + curAngle;
}

// prparer le groupe
groupObjects = new Array ();

// l'objet slectionn
curFrame = curSel[0];

// appeler la fonction pour appliquer la couleur et la teinte
if (bColor != dontChange) {
	setBgrColr(bColor, bgrT);
}

// appeler la fonction pour appliquer le contour, sa couleur, sa teinte et son alignement
if (sColor != dontChange) {
	setStroke(sColor, strW, strT, strA);
}

// appeler la fontion qui mmorise les dimensions
defVal = getBounds();
y1 = defVal[0];
x1 = defVal[1];
y2 = defVal[2];
x2 = defVal[3];

// arrondir les valeurs
var objH = (Math.floor(((y2-y1)*1000)+0.5))/1000;
var objW = (Math.floor(((x2-x1)*1000)+0.5))/1000;

// dfinir des variables dont la valeur n'est pas dfinissable dans le dialogue
compVal = 1;
offVal  = (objW*1.0738032)+dVal;
moveVal = (objW/3.2)*1;

if (rVal == 0) { // lorsque la valeur du rayon est zro
	// appeler la fonction qui duplique les objets dans le sens des aiguilles de l'horloge
	if (objH == objW) { // un objet carr
		duplObjSquare();
	}
	else { // l'objet est rctangulaire
		if (elWd) {
			duplObjLongElast();
		}
		else {
			duplObjLong();
		}
	}
}
else {
	if ((rVal/(objW+dVal)) > 2.35) {
		if ((frmW-(rVal*2)) > (objW*2)+(dVal*3)) {
			// appeler la fonction qui arrondit les coins
			roundedCorners();
		}
		else {
			// appeler la fonction qui place les objets dans un cercle parfait
			perfectCircle();
		}
	}
	else {
		// quand la valeur du rayon est trop petite, les coins sont 
		// "arrondis" en ne pivotant qu'un seul objet par coin
		
		// appeler la fonction qui duplique l'objet
		roundedOne();
		
		// appeler la fonction qui pivote les objets coins
		rotateObj();
		
		// appeler la fonction qui dplace les objets coins
		moveObj();
	}
}

// appeler la fonction qui groupe les objets
var curGroup = groupObj(groupObjects);

// les "bounds" du groupe final
if (!strVisible) {
	gB = curGroup.geometricBounds;
	// appliquer la hauteur et la largeur afin de corriger une ventuelle diffrence  cause d'un arrondissment
	curGroup.geometricBounds = [gB[0], gB[1], gB[0] + frmH, gB[1] + frmW];
}

// dissoudre le groupe (quand la case n'tait pas coche)
if (!grFr) {
	curGroup.ungroup();
}

// dselectionner
app.selection = null;

// appeler la fonction qui rstore les rglages
restorePrefs();

////////////////////////////// la fonction "getPrefs"  (le dbut)  ////////////////////////////////////////////
// la fonction qui prpare les informations
function getPrefs() {
	var allPrefs = "";
	// lire le fichier qui contient les valeurs mmorises
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/CreerCadre_01.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}
////////////////////////////// la fonction "getPrefs"  (la fin)  /////////////////////////////////////////////

////////////////////////////// la fonction "getBgrColorList"  (le dbut)  ////////////////////////////////////
// la fonction qui prpare la liste des nuances de fond
function getBgrColorList(bName) {
	// dfinir une variable comme rfrence aux nuances du document actif
	var allSwatches = curDoc.swatches;
	
	// vrfier si la nuance par dfaut existe
	if (bName != dontChange && bName != "[" + blackCol + "]" && bName != "[Papier]" && bName != noColor && bName != rgColor) {
		try {
			curDoc.swatches.itemByName(bName).name;
		}
		catch (e) {
			bName = "[" + blackCol + "]";
		}
	}
	
	// assembler la liste des nuances;
	// renommer "None", "Paper", "Black" et "Registration";
	// mmoriser la position de la nuance par dfaut
	var bgrColorList = new Array(dontChange);
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = "[Papier]";
		}
		else if (cName == "Black") {
			cName = "[" + blackCol + "]";
		}
		else if (cName == "Registration") {
			cName = rgColor;
		}
		if (bName == cName) {
			bIndex = i;
		}
		if (cName != "Registration") {
			bgrColorList.push(cName);
		}
	}
	if (bName == dontChange) {
		bIndex = 0;
	}
	else {
		bIndex++;
	}
	return [bgrColorList, bIndex];
}
////////////////////////////// la fonction "getBgrColorList"  (la fin)  //////////////////////////////////////

////////////////////////////// la fonction "getStrColorList"  (le dbut)  ////////////////////////////////////
// la fonction qui prpare la liste des nuances pour le contour
function getStrColorList(sName) {
	// dfinir une variable comme rfrence aux nuances du document actif
	var allSwatches = curDoc.swatches;
	
	// vrfier si la nuance par dfaut existe
	if (sName != dontChange && sName != "[" + blackCol + "]" && sName != "[Papier]" && sName != noColor && sName != rgColor) {
		try {
			curDoc.swatches.itemByName(sName).name;
		}
		catch (e) {
			sName = "[" + blackCol + "]";
		}
	}
	
	// assembler la liste des nuances;
	// renommer "None", "Paper", "Black" et "Registration";
	// mmoriser la position de la nuance par dfaut
	var strColorList = new Array(dontChange);
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = "[Papier]";
		}
		else if (cName == "Black") {
			cName = "[" + blackCol + "]";
		}
		else if (cName == "Registration") {
			cName = rgColor;
		}
		if (sName == cName) {
			sIndex = i;
		}
		if (cName != "Registration") {
			strColorList.push(cName);
		}
	}
	if (sName == dontChange) {
		sIndex = 0;
	}
	else {
		sIndex++;
	}
	return [strColorList, sIndex];
}
////////////////////////////// la fonction "getStrColorList"  (la fin)  //////////////////////////////////////

////////////////////////////// la fonction "displayDialog"  (le dbut)  //////////////////////////////////////
// une fonction pour montrer un dialogue et trater le rsultat
function displayDialog(frmW, frmH, dVal, rVal, ck01, ck02, bInd, bgrT, sInd, strT, strW, rb01, rb02, rb03, rb04, rb05, rb06, rb07, rb08, rb09, rb10, rb11) {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 120;
	var fieldWidth =  40;
	var aDialog = app.dialogs.add({name:"CreerUnCadre"});
	with (aDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Largeur du cadre", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var widthField = realEditboxes.add({editValue:frmW, minimumValue:10, maximumValue:9999, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Hauteur du cadre", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var heightField = realEditboxes.add({editValue:frmH, minimumValue:10, maximumValue:9999, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Espacer les objets", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var distField = realEditboxes.add({editValue:dVal, minimumValue:-10, maximumValue:9999, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Le rayon", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var radiField = realEditboxes.add({editValue:rVal, minimumValue:0, maximumValue:9999, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		var elasCheckbox = checkboxControls.add({staticLabel:"Largeur de l'objet lastique", checkedState:ck01});
		var grpeCheckbox = checkboxControls.add({staticLabel:"Grouper les lments du cadre", checkedState:ck02});
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Couleur du fond", minWidth:labelWidth-10});
					staticTexts.add({staticLabel:" "});
				}
				var bgrColor = dropdowns.add({stringList:bgrCol, selectedIndex:bInd, minWidth:130});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"La teinte", minWidth:labelWidth-10});
					var bgrTint = realEditboxes.add({editValue:bgrT, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"%", minWidth:12});
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Le contour", minWidth:labelWidth-10});
					staticTexts.add({staticLabel:" "});
				}
				var strColor = dropdowns.add({stringList:strCol, selectedIndex:sInd, minWidth:130});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"La teinte", minWidth:labelWidth-10});
					var strTint = realEditboxes.add({editValue:strT, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"%", minWidth:12});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"L'paisseur", minWidth:labelWidth-10});
					var strWeight = realEditboxes.add({editValue:strW, minimumValue:0, maximumValue:5, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"pt", minWidth:12});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"L'alignement", minWidth:labelWidth-10});
					with(aligButtons = radiobuttonGroups.add()){
						radiobuttonControls.add({staticLabel:"centrer", checkedState:rb01});
						radiobuttonControls.add({staticLabel:"intrieur",  checkedState:rb02});
						radiobuttonControls.add({staticLabel:"extrieur", checkedState:rb03});
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Pivoter les lments", minWidth:20});
					staticTexts.add({staticLabel:" ", minWidth:20});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"", minWidth:16});
					with(rotationButtons = radiobuttonGroups.add()){
						radiobuttonControls.add({staticLabel:"Les pointes vers l'intrieur", checkedState:rb04});
						radiobuttonControls.add({staticLabel:"Les pointes vers l'extrieur", checkedState:rb05});
						radiobuttonControls.add({staticLabel:"En carousel vers la gauche",   checkedState:rb06});
						radiobuttonControls.add({staticLabel:"En carousel vers la droite",   checkedState:rb07});
						radiobuttonControls.add({staticLabel:"Les pointes vers le bas",      checkedState:rb08});
						radiobuttonControls.add({staticLabel:"Les pointes vers la gauche",   checkedState:rb09});
						radiobuttonControls.add({staticLabel:"Les pointes vers le haut",     checkedState:rb10});
						radiobuttonControls.add({staticLabel:"Les pointes vers la droite",   checkedState:rb11});
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		var frmW = widthField.editValue;
		var frmH = heightField.editValue;
		var dVal = distField.editValue;
		var rVal = radiField.editValue;
		var ck01 = elasCheckbox.checkedState;
		var ck02 = grpeCheckbox.checkedState;
		bgrIndex = bgrColor.selectedIndex;
		if (bgrIndex != 0) {
			bColor = curDoc.swatches[bgrIndex-1].name;
		}
		else {
			bColor = dontChange;
		}
		if (bColor == "[" + blackCol + "]") { bColor = "Black"; }
		else if (bColor == "[Papier]") { bColor = "Paper"; }
		else if (bColor == rgColor) { bColor = "Registration"; }
		else if (bColor == noColor) { bColor = "None"; }
		bgrT = bgrTint.editValue;
		strIndex = strColor.selectedIndex;
		if (strIndex != 0) {
			sColor = curDoc.swatches[strIndex-1].name;
		}
		else {
			sColor = dontChange;
		}
		if (sColor == "[" + blackCol + "]") { sColor = "Black"; }
		else if (sColor == "[Papier]") { sColor = "Paper"; }
		else if (sColor == rgColor) { sColor = "Registration"; }
		else if (sColor == noColor) { sColor = "None"; }
		strT = strTint.editValue;
		strW = strWeight.editValue;
		var aligDec = aligButtons.selectedButton;
		if (aligDec == 0) {
			strA = 1936998723; // centrer
		}
		else if (aligDec == 1) {
			strA = 1936998729; // intrieur
		}
		else if (aligDec == 2) {
			strA = 1936998735; // extrieur
		}
		var rDec = rotationButtons.selectedButton;
		aDialog.destroy();
		var prefsList = new Array (frmW, frmH, dVal, rVal, ck01, ck02, bColor, bgrT, sColor, strT, strW, aligDec, rDec);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		return [frmW, frmH, dVal, rVal, ck01, ck02, bColor, bgrT, sColor, strT, strW, strA, rDec];
	}
	else{
		aDialog.destroy();
		restorePrefs();
		exit();
	}
}
////////////////////////////// la fonction "displayDialog"  (la fin)  ////////////////////////////////////////

////////////////////////////// la fonction "writeResult"  (le dbut)  ////////////////////////////////////////
// crire le rsultat dans un fichier
function writeResult(curPrefs) {
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/CreerCadre_01.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}
////////////////////////////// la fonction "writeResult"  (la fin)  //////////////////////////////////////////

////////////////////////////// la fonction "setbgrColr"  (le dbut)  /////////////////////////////////////////
// la fonction qui applique la nuance du fond et sa teinte
function setBgrColr(bColor, bgrT) {
	try {
		if (bColor != 0) {
			if (bColor == "Papier") {  // renommer "Papier" en "Paper"
				bColor = "Paper";
			}
			else if (bColor == " + blackCol + ") {  // renommer "Noir" en "Black"
				bColor = "Black";
			}
			// modifier une teinte de 100 en un -1 plus correct
			if (bgrT == 100) {
				bgrT = -1;
			}
			// appliquer la nuance et la teinte
			curFrame.properties = {fillColor:bColor, fillTint:bgrT};
		}
	}
	catch (e) {
		restorePrefs();
		exit();
	}
}
////////////////////////////// la fonction "setBgrColr"  (la fin)  ///////////////////////////////////////////

////////////////////////////// la fonction "setStroke"  (le dbut)  //////////////////////////////////////////
// la fonction qui applique l'paisseur du contour, sa nuance et sa teinte
function setStroke(sColor, strW, strT, strA) {
	try {
		if (sColor == "Papier") {  // renommer "Papier" en "Paper"
			sColor = "Paper";
		}
		else if (sColor == " + blackCol + ") {  // renommer "Noir" en "Black"
			sColor = "Black";
		}
		// modifier une teinte de 100 en un -1 plus correct
		if (strT == 100) {
			strT = -1;
		}
		// appliquer la nuance, l'paisseur, la teinte et l'alignement
		curFrame.properties = {strokeColor:sColor, strokeWeight:strW, strokeTint:strT, strokeAlignment:strA};
	}
	catch (e) {
		restorePrefs();
		exit();
	}
}
////////////////////////////// la fonction "setStroke"  (la fin)  ////////////////////////////////////////////

////////////////////////////// la fonction "getBounds"  (le dbut)  //////////////////////////////////////////
// la fonction qui mmorise les valeur de la dimension de l'objet
function getBounds() {
	// vrifier le contour
	strVisible = false;
	var curStrC = curFrame.strokeColor.name;
	if (curStrC != "None") {
		var curStrA = curFrame.strokeAlignment;
		if (curStrA != 1936998729) { // l'alignement n'est pas "intrieur"
			strVisible = true;
		}
	}
	else {
		if (curFrame.constructor.name == "GraphicLine") {
			strVisible = true;
		}
	}
	if (strVisible) {
		// mmoriser les "bounds" visibles de l'objet...
		var vB = curFrame.visibleBounds;
		var y0 = (Math.floor((vB[0]*1000)+0.5))/1000;
		var x0 = (Math.floor((vB[1]*1000)+0.5))/1000;
		var y1 = (Math.floor((vB[0]*1000)+0.5))/1000;
		var x1 = (Math.floor((vB[1]*1000)+0.5))/1000;
		var y2 = (Math.floor((vB[2]*1000)+0.5))/1000;
		var x2 = (Math.floor((vB[3]*1000)+0.5))/1000;
		// appliquer l'angle de rotation pour la ligne en haut
		curFrame.rotationAngle = topLineRot;
		// mmoriser encore une fois les "bounds" visibles de l'objet...
		var vB = curFrame.geometricBounds;
		var y1 = (Math.floor((vB[0]*1000)+0.5))/1000;
		var x1 = (Math.floor((vB[1]*1000)+0.5))/1000;
		var y2 = (Math.floor((vB[2]*1000)+0.5))/1000;
		var x2 = (Math.floor((vB[3]*1000)+0.5))/1000;
	}
	else {
		// mmoriser les "bounds" gomtriques de l'objet...
		var gB = curFrame.geometricBounds;
		var y0 = (Math.floor((gB[0]*1000)+0.5))/1000;
		var x0 = (Math.floor((gB[1]*1000)+0.5))/1000;
		var y1 = (Math.floor((gB[0]*1000)+0.5))/1000;
		var x1 = (Math.floor((gB[1]*1000)+0.5))/1000;
		var y2 = (Math.floor((gB[2]*1000)+0.5))/1000;
		var x2 = (Math.floor((gB[3]*1000)+0.5))/1000;
		// appliquer l'angle de rotation pour la ligne en haut
		curFrame.rotationAngle = topLineRot;
		// mmoriser encore une fois les "bounds" gomtriques de l'objet...
		var gB = curFrame.geometricBounds;
		var y1 = (Math.floor((gB[0]*1000)+0.5))/1000;
		var x1 = (Math.floor((gB[1]*1000)+0.5))/1000;
		var y2 = (Math.floor((gB[2]*1000)+0.5))/1000;
		var x2 = (Math.floor((gB[3]*1000)+0.5))/1000;
	}
	
	// dplacer l'objet si la rotation a modifi sa position
	if (y0 != y1 || x0 != x1) {
		curFrame.move(undefined, [(x0-x1), (y0-y1)]);
	}
	return [y1, x1, y2, x2];
}
////////////////////////////// la fonction "getBounds"  (la fin)  ////////////////////////////////////////////

////////////////////////////// la fonction "duplObjSquare"  (le dbut)  //////////////////////////////////////
// la fonction pour dupliquer un objet carr dans le sens des aiguilles de l'horloge
function duplObjSquare() {
	// mettre l'objet de base dans la liste du futur groupe
	groupObjects.push(curFrame);
	// la largeur de l'objet
	var oneWidth  = (Math.floor(((x2-x1)*1000)+0.5))/1000;
	// le nombre des lments horizontaux
	var nItemsHor = (Math.floor((frmW+dVal)/(oneWidth+dVal)));
	// la distance rlle et le dcalage
	var realXSpace = (Math.floor(((frmW-(nItemsHor*oneWidth))/(nItemsHor-1)*1000)+0.5))/1000;
	var xOffset = oneWidth+realXSpace;
	// la hauteur de l'objet
	var oneHeight  = (Math.floor(((y2-y1)*1000)+0.5))/1000;
	// le nombre des lments verticaux
	var nItemsVer = Math.floor((frmH-((oneHeight*2)+dVal))/(oneHeight+dVal));
	var realYSpace = (Math.floor(((frmH-(nItemsVer*oneHeight)-(oneHeight*2))/(nItemsVer+1)*1000)+0.5))/1000;
	var yOffset = oneHeight+realYSpace;
	
	// si "lastique", adapter la hauteur et la largeur
	if (elWd) {
		oneWidth  = (frmW - ((nItemsHor-1)*dVal))/ nItemsHor;
		oneHeight = (frmH - ((nItemsVer+1)*dVal))/(nItemsVer+2);
		if (strVisible) {
			// mmoriser les "bounds" visibles de l'objet
			vB = curFrame.visibleBounds;
			y1 = (Math.floor((vB[0]*1000)+0.5))/1000;
			x1 = (Math.floor((vB[1]*1000)+0.5))/1000;
			curFrame.visibleBounds = [y1, x1, y1+oneHeight, x1+oneWidth];
		}
		else {
			// mmoriser les "bounds" gometriques de l'objet
			gB = curFrame.geometricBounds;
			y1 = (Math.floor((gB[0]*1000)+0.5))/1000;
			x1 = (Math.floor((gB[1]*1000)+0.5))/1000;
			curFrame.geometricBounds = [y1, x1, y1+oneHeight, x1+oneWidth];
		}
		var xOffset = oneWidth+dVal;
		var yOffset = oneHeight+dVal;
	}
	
	// ---------- les quatre bords ----------
	// le bord suprieur (de gauche  droite)
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [xOffset, 0]);
		groupObjects.push(curFrame);
	}
	// le bord droit (du haut vers le bas)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = rgtLineRot;
	curFrame.move(undefined, [0, yOffset]);
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, yOffset]);
		groupObjects.push(curFrame);
	}
	// le bord infrieur (de la droite vers la gauche)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = botLineRot;
	curFrame.move(undefined, [0, yOffset]);
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [-xOffset, 0]);
		groupObjects.push(curFrame);
	}
	// le bord gauche (du bas vers le haut)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = lftLineRot;
	curFrame.move(undefined, [0, -yOffset]);
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, -yOffset]);
		groupObjects.push(curFrame);
	}
}
////////////////////////////// la fonction "duplObjSquare"  (la fin)  ////////////////////////////////////////

////////////////////////////// la fonction "duplObjLong"  (le dbut)  ////////////////////////////////////////
// la fonction pour dupliquer un objet rectangulaire dans le sens des aiguilles de l'horloge
function duplObjLong() {
	// mettre l'objet de base dans la liste du futur groupe
	groupObjects.push(curFrame);
	// la largeur de l'objet
	var oneWidth  = (Math.floor(((x2-x1)*1000)+0.5))/1000;
	// le nombre des lments horizontaux
	var nItemsHor = (Math.floor((frmW+dVal)/(oneWidth+dVal)));
	var realXSpace = (Math.floor(((frmW-(nItemsHor*oneWidth))/(nItemsHor-1)*1000)+0.5))/1000;
	var xOffset = oneWidth+realXSpace;
	// faire la diffrence entre objets pivots et non pivots
	if (noRota || (rDec == 5) || (rDec == 7)) {
		// la hauteur de l'lment
		var oneHeight = (Math.floor(((y2-y1)*1000)+0.5))/1000;
		// le nombre d'lments verticaux et le dcalage
		var nItemsVer = Math.floor((frmH-((oneHeight*2)+dVal))/(oneHeight+dVal));
		var realYSpace = (Math.floor(((frmH-(nItemsVer*oneHeight)-(oneHeight*2))/(nItemsVer+1)*1000)+0.5))/1000;
		var yOffset = oneHeight+realYSpace;
	}
	else {
		// la largeur de l'objet devient la hauteur, une nouvelle valeur pour la largeur
		var oneHeight = oneWidth;
		var oneWidth  = (Math.floor(((y2-y1)*1000)+0.5))/1000;
		// le nombre d'lments verticaux et le dcalage
		var nItemsVer = Math.floor((frmH-((oneWidth*2)+dVal))/(oneHeight+dVal));
		var realYSpace = (Math.floor(((frmH-(nItemsVer*oneHeight)-(oneWidth*2))/(nItemsVer+1)*1000)+0.5))/1000;
		var yOffset = oneHeight+realYSpace;
	}
	
	// ---------- les quatre bords ----------
	// le bord suprieur (de gauche  droite)
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [xOffset, 0]);
		groupObjects.push(curFrame);
	}
	// le bord droit (du haut vers le bas)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = rgtLineRot;
	if (noRota || (rDec == 5) || (rDec == 7)) {
		curFrame.move(undefined, [0, yOffset]);
	}
	else {
		curFrame.move(undefined, [(oneHeight/2)-(oneWidth/2), (oneHeight/2)+(oneWidth/2)+realYSpace]);
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, yOffset]);
		groupObjects.push(curFrame);
	}
	// le bord infrieur (de la droite vers la gauche)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = botLineRot;
	if (noRota || (rDec == 5) || (rDec == 7)) {
		curFrame.move(undefined, [0, yOffset]);
	}
	else {
		curFrame.move(undefined, [-((oneHeight/2)-(oneWidth/2)), (oneHeight/2)+(oneWidth/2)+realYSpace]);
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [-xOffset, 0]);
		groupObjects.push(curFrame);
	}
	// le bord gauche (du bas vers le haut)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = lftLineRot;
	if (noRota || (rDec == 5) || (rDec == 7)) {
		curFrame.move(undefined, [0, -yOffset]);
	}
	else {
		curFrame.move(undefined, [-((oneHeight/2)-(oneWidth/2)), -((oneHeight/2)+(oneWidth/2)+realYSpace)]);
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, -yOffset]);
		groupObjects.push(curFrame);
	}
}
////////////////////////////// la fonction "duplObjLong"  (la fin)  //////////////////////////////////////////

////////////////////////////// la fonction "duplObjLongELAST"  (le dbut)  ///////////////////////////////////
// la fonction pour dupliquer un objet rectangulaire dans le sens des aiguilles de l'horloge et l'adapter lastiquement
function duplObjLongElast() {
	// mettre l'objet de base dans la liste du futur groupe
	groupObjects.push(curFrame);
	// la largeur de l'objet
	var oneWidthX  = (Math.floor(((x2-x1)*1000)+0.5))/1000;
	// la hauteur de l'lment
	var oneHeightX = (Math.floor(((y2-y1)*1000)+0.5))/1000;
	// le nombre des lments horizontaux
	var nItemsHor = (Math.floor((frmW+dVal)/(oneWidthX+dVal)));
	var elaWidthX = (frmW-((nItemsHor-1)*dVal))/nItemsHor;
	x2 = x1+elaWidthX;
	curFrame.geometricBounds = [y1, x1, y2, x2];
	var xOffset = elaWidthX+dVal;
	// faire la diffrence entre objets pivots et non pivots
	if (noRota || (rDec == 5) || (rDec == 7)) {
		// le nombre d'lments verticaux et le dcalage
		var nItemsVer = Math.floor((frmH-((oneHeightX*2)+dVal))/(oneHeightX+dVal));
		var realYSpace = (Math.floor(((frmH-(nItemsVer*oneHeightX)-(oneHeightX*2))/(nItemsVer+1)*1000)+0.5))/1000;
		var yOffset = oneHeightX+realYSpace;
	}
	else {
		// l'ancienne largeur de l'objet devient la hauteur, une nouvelle valeur pour la largeur
		var oneHeightY = oneWidthX;
		var oneWidthY  = (Math.floor(((y2-y1)*1000)+0.5))/1000;
		// le nombre d'lments verticaux et le dcalage
		var nItemsVer = (Math.floor((frmH-((oneHeightX*2)+dVal))/(oneHeightY+dVal)))+1;
		var elaHeightY = (frmH-((oneHeightX*2)+dVal)-((nItemsVer)*dVal))/nItemsVer;
		var realYSpace = dVal;
		var yOffset = elaHeightY+dVal;
	}
	
	// ---------- les quatre bords ----------
	// le bord suprieur (de gauche  droite)
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [xOffset, 0]);
		groupObjects.push(curFrame);
	}
	// le bord droit (du haut vers le bas)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = rgtLineRot;
	if (noRota || (rDec == 5) || (rDec == 7)) {
		curFrame.move(undefined, [0, yOffset]);
	}
	else {
		curFrame.move(undefined, [(elaWidthX/2)-(oneHeightX/2), (oneHeightX/2)+(elaWidthX/2)+dVal]);
		gB = curFrame.geometricBounds;
		y1 = gB[0];
		x1 = gB[1];
		y2 = y1 + elaHeightY;
		x2 = gB[3];
		curFrame.geometricBounds = [y1, x1, y2, x2];
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, yOffset]);
		groupObjects.push(curFrame);
	}
	// le bord infrieur (de la droite vers la gauche)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = botLineRot;
	if (noRota || (rDec == 5) || (rDec == 7)) {
		curFrame.move(undefined, [0, yOffset]);
	}
	else {
		curFrame.move(undefined, [-((elaHeightY/2)-(oneWidthY/2)), (elaHeightY/2)+(oneWidthY/2)+realYSpace]);
		gB = curFrame.geometricBounds;
		y1 = gB[0];
		x1 = gB[3] - elaWidthX;
		y2 = gB[2];
		x2 = gB[3];
		curFrame.geometricBounds = [y1, x1, y2, x2];
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [-xOffset, 0]);
		groupObjects.push(curFrame);
	}
	// le bord gauche (du bas vers le haut)
	curFrame = curFrame.duplicate();
	curFrame.rotationAngle = lftLineRot;
	if (noRota || (rDec == 5) || (rDec == 7)) {
		curFrame.move(undefined, [0, -yOffset]);
	}
	else {
		curFrame.move(undefined, [-((elaWidthX/2)-(oneHeightX/2)), -((oneHeightX/2)+(elaWidthX/2)+dVal)]);
		gB = curFrame.geometricBounds;
		y1 = gB[2] - elaHeightY;
		x1 = gB[1];
		y2 = gB[2];
		x2 = gB[3];
		curFrame.geometricBounds = [y1, x1, y2, x2];
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, -yOffset]);
		groupObjects.push(curFrame);
	}
}
////////////////////////////// la fonction "duplObjLongElast"  (la fin)  /////////////////////////////////////

////////////////////////////// la fonction "roundedCorners"  (le dbut)  /////////////////////////////////////
// la fonction pour arrondir les coins
function roundedCorners() {
	// mettre l'objet de base dans la liste du futur groupe
	groupObjects.push(curFrame);
	if (strVisible) {
		// mmoriser les "bounds" visibles de l'objet...
		vB = curFrame.visibleBounds;
		y1 = (Math.floor((vB[0]*1000)+0.5))/1000;
		x1 = (Math.floor((vB[1]*1000)+0.5))/1000;
		y2 = (Math.floor((vB[2]*1000)+0.5))/1000;
		x2 = (Math.floor((vB[3]*1000)+0.5))/1000;
	}
	else {
		// mmoriser les "bounds" gomtriques de l'objet...
		gB = curFrame.geometricBounds;
		y1 = (Math.floor((gB[0]*1000)+0.5))/1000;
		x1 = (Math.floor((gB[1]*1000)+0.5))/1000;
		y2 = (Math.floor((gB[2]*1000)+0.5))/1000;
		x2 = (Math.floor((gB[3]*1000)+0.5))/1000;
	}
	// la largeur et la hauteur
	oneWidth  = x2-x1;
	oneHeight = y2-y1;
	
	// le rayon extrieur
	var oRad = rVal;
	// le rayon mdian
	var mRad = oRad-(objW/2)
	var pi   = 3.14159;
	// la longueur d'un quart de cercle (rayon mdian = la position des centres des objets)
	var sectM = (2*pi*mRad)/4;
	// la longueur d'un quart de cercle (rayon d'origine, multipli par un valeur de compensation)
	// selon l'lment la valeur  rpartir est influence, afin d'obtenir des distances sur 
	// les secteurs de cercle et les droites *optiquement* identiques
	var sectR = ((2*pi*oRad)/4)*compVal;
	
	// le nombre d'lments sur le quart de cercle
	var nItems = (Math.floor(sectM/(objW+dVal)))-1;
	// le nombre d'lments sur les droites
	var nHorItems = (Math.floor((frmW-(oRad*2))/(oneWidth+dVal)))+1;
	var nVerItems = (Math.floor((frmH-(oRad*2))/(oneHeight+dVal)))+1;
	
	// si lastique, adapter la largeur et la hauteur
	if (elWd) {
		oneWidth  = ((frmW-(oRad*2)) + oneWidth - ((nHorItems-1)*dVal))/(nHorItems);
		oneHeight = ((frmH-(oRad*2)) + oneHeight - ((nVerItems-1)*dVal))/(nVerItems);
		curFrame.visibleBounds = [y1, x1, y1+oneHeight, x1+oneWidth];
	}
	
	// additionner les espaces...
	var distSector = sectR-((nItems+1)*oneWidth);
	var distStrght = (frmW-(oRad*2))-((nHorItems-1)*oneWidth);
	// ... calculer la distance idale...
	var distIdeal  = ((distSector*4)+(distStrght*4))/((nItems*4)+(nHorItems*4));
	// ... et calculer, finalement, le nouveau rayon
	oRad = (frmW-((nHorItems-1)*oneWidth)-((nHorItems-1)*distIdeal))/2;
	
	// si lastique, adapter une nouvelle fois la largeur et la hauteur
	if (elWd) {
		oneWidth  = ((frmW-(oRad*2)) + oneWidth - ((nHorItems-1)*dVal))/(nHorItems);
		oneHeight = ((frmH-(oRad*2)) + oneHeight - ((nVerItems-1)*dVal))/(nVerItems);
		curFrame.visibleBounds = [y1, x1, y1+oneHeight, x1+oneWidth];
	}
	
	// ---------- prparer les nouvelles valeurs dfinitives ----------
	// le rayon mdian
	var mRad = oRad-(oneWidth/2);
	
	// le nombre de tous les lments
	var nAllItems = (nItems*4)+(nHorItems*2)+(nVerItems*2);
	
	// le dcalage rl
	if (elWd) {
		var realXOff = oneWidth+dVal;
		var realYOff = oneHeight+dVal;
	}
	else {
		var realXOff = (frmW-(oRad*2))/(nHorItems-1);
		var realYOff = (frmH-(oRad*2))/(nVerItems-1);
	}
	
	// la valeur du pas
	var oneAngle = 90/(nItems+1);
	
	// les angles des lments de base
	var angListBE = new Array ();
	var curAngle = 90;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListBE.push(newAngle);
		curAngle = newAngle;
	}
	
	// les angles des lments des coins
	// le coin en haut,  gauche
	var angListTL = new Array ();
	var curAngle = lftLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListTL.push(newAngle);
		curAngle = newAngle;
	}
	// le coin en haut,  droite
	var angListTR = new Array ();
	var curAngle = topLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListTR.push(newAngle);
		curAngle = newAngle;
	}
	// le coin en bas,  droite
	var angListBR = new Array ();
	var curAngle = rgtLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListBR.push(newAngle);
		curAngle = newAngle;
	}
	// le coin en bas,  gauche
	var angListBL = new Array ();
	var curAngle = botLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListBL.push(newAngle);
		curAngle = newAngle;
	}
	
	// les angles des lments droites
	// le bord en haut
	var angListT = new Array ();
	for (var i=0; i<nHorItems; i++) {
		angListT.push(topLineRot);
	}
	// le bord droit
	var angListR = new Array ();
	for (var i=0; i<nVerItems; i++) {
		angListR.push(rgtLineRot);
	}
	// le bord en bas
	var angListB = new Array ();
	for (var i=0; i<nHorItems; i++) {
		angListB.push(botLineRot);
	}
	// le bord  gauche
	var angListL = new Array ();
	for (var i=0; i<nVerItems; i++) {
		angListL.push(lftLineRot);
	}
	
	// les paramtres des positions de tous les lments des coins 
	// le coin en haut,  gauche
	var posListTL = new Array ();
	for (var i=nItems-1; i>-1; i--) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (oRad-(mRad*xPos))-(oneWidth/2);
		var yPos = Math.sin(curVal);
		y = (oRad-(mRad*yPos))-(oneHeight/2);
		posListTL.push([x,y]);
	}
	// le coin en haut,  droite
	var posListTR = new Array ();
	for (var i=0; i<nItems; i++) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (frmW-(oRad-(mRad*xPos)))-(oneWidth/2);
		var yPos = Math.sin(curVal);
		y = (oRad-(mRad*yPos))-(oneHeight/2);
		posListTR.push([x,y]);
	}
	// le coin en bas,  droite
	var posListBR = new Array ();
	for (var i=nItems-1; i>-1; i--) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (frmW-(oRad-(mRad*xPos)))-(oneWidth/2);
		var yPos = Math.sin(curVal);
		y = (frmH-(oRad-(mRad*yPos)))-(oneHeight/2);
		posListBR.push([x,y]);
	}
	// le coin en bas,  gauche
	var posListBL = new Array ();
	for (var i=0; i<nItems; i++) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (oRad-(mRad*xPos))-(oneWidth/2);
		var yPos = Math.sin(curVal);
		y = (frmH-(oRad-(mRad*yPos)))-(oneHeight/2);
		posListBL.push([x,y]);
	}
	
	// les paramtres des positions de tous les lments des droites
	// le bord en haut
	var posListT = new Array ();
	var curVal = oRad-(oneWidth/2);
	for (var i=0; i<nHorItems; i++) {
		posListT.push([curVal, 0]);
		curVal += realXOff;
	}
	// le bord droit
	var posListR = new Array ();
	var curVal = oRad-(oneWidth/2);
	for (var i=0; i<nVerItems; i++) {
		posListR.push([frmW-oneWidth, curVal]);
		curVal += realYOff;
	}
	// le bord en bas
	var posListB = new Array ();
	var curVal = (frmW-oRad)-(oneWidth/2);
	for (var i=0; i<nHorItems; i++) {
		posListB.push([curVal, frmH-oneHeight]);
		curVal -= realXOff;
	}
	// le bord  gauche
	var posListL = new Array ();
	var curVal = (frmH-oRad)-(oneHeight/2);
	for (var i=0; i<nVerItems; i++) {
		posListL.push([0, curVal]);
		curVal -= realYOff;
	}
	// la liste des tous les paramtres des positions
	var allPosList = posListTL.concat(posListT, posListTR, posListR, posListBR, posListB, posListBL, posListL);
	
	// la liste des tous les angles
	var allAngList = angListTL.concat(angListT, angListTR, angListR, angListBR, angListB, angListBL, angListL);
	
	// lorsque les angles dsirs sont identiques, adapter la liste des angles
	if ((topLineRot == rgtLineRot) && (topLineRot == botLineRot) && (topLineRot == lftLineRot)) {
		var nVals = allAngList.length;
		for (var i=0; i<nVals; i++) {
			allAngList[i] = topLineRot;
		}
	}
	
	// dupliquer l'objet selon le nombre dsir
	if (versNum == 7) {
		curFrame.name = "0_";
		for (var i=0; i<nAllItems-1; i++) {
			curFrame = curFrame.duplicate(undefined, [0, 0]);
			curFrame.name = "" + (i+1) + "_";
			groupObjects.push(curFrame);
		}
	}
	else {
		curFrame.label = "0_";
		for (var i=0; i<nAllItems-1; i++) {
			curFrame = curFrame.duplicate(undefined, [0, 0]);
			curFrame.label = "" + (i+1) + "_";
			groupObjects.push(curFrame);
		}
	}
	
	// dplacer les objets  tour de rle  leurs positions 
	// et appliquer la valeur de l'angle de rotation
	for (var i=0; i<nAllItems; i++) {
		curDoc.pageItems.itemByName("" + i + "_").move(allPosList[i], undefined);
		curDoc.pageItems.itemByName("" + i + "_").rotationAngle = (allAngList[i]);
		curDoc.pageItems.itemByName("" + i + "_").move(undefined, [x1, y1]);
		if (versNum == 7) {
			curDoc.pageItems.itemByName("" + i + "_").name = "";
		}
		else {
			curDoc.pageItems.itemByName("" + i + "_").label = "";
		}
	}
}
////////////////////////////// la fonction "roundedCorners"  (la fin)  ///////////////////////////////////////

////////////////////////////// la fonction "perfectCircle"  (le dbut)  //////////////////////////////////////
function perfectCircle() {
	// le rayon extrieur
	oRad = frmW/2;
	
	// le rayon mdian et la longueur d'un quart de cercle
	var mRad = oRad-(objW/2)
	var pi   = 3.14159;
	var sect = (2*pi*oRad)/4;
	
	// le nombre d'lments sur le quart de cercle
	var nItems = (Math.floor(sect/(objW+dVal)))-1;
	if (nItems == Infinity || nItems < 1) {
		alert ("Un problme:\n\nL'objet ne peut pas tre dupliqu.", " ");
		restorePrefs();
		exit();
	}
	// le nombre de tous les lments
	var nHorItems = 1;
	var nVerItems = 1;
	var nAllItems = (nItems*4)+2+2;
	
	// la valeur du pas
	var oneAngle = 90/(nItems+1);
	
	// les angles des lments de base
	var angListBE = new Array ();
	var curAngle = 90;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListBE.push(newAngle);
		curAngle = newAngle;
	}
	
	// les angles des lments des coins
	// le coin en haut,  gauche
	var angListTL = new Array ();
	var curAngle = lftLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListTL.push(newAngle);
		curAngle = newAngle;
	}
	// le coin en haut,  droite
	var angListTR = new Array ();
	var curAngle = topLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListTR.push(newAngle);
		curAngle = newAngle;
	}
	// le coin en bas,  droite
	var angListBR = new Array ();
	var curAngle = rgtLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListBR.push(newAngle);
		curAngle = newAngle;
	}
	// le coin en bas,  gauche
	var angListBL = new Array ();
	var curAngle = botLineRot;
	for (var i=0; i<nItems; i++) {
		newAngle = curAngle-oneAngle;
		angListBL.push(newAngle);
		curAngle = newAngle;
	}
	
	// les angles des lments droites
	// le bord en haut
	var angListT = new Array ();
	for (var i=0; i<nHorItems; i++) {
		angListT.push(topLineRot);
	}
	// le bord droit
	var angListR = new Array ();
	for (var i=0; i<nVerItems; i++) {
		angListR.push(rgtLineRot);
	}
	// le bord en bas
	var angListB = new Array ();
	for (var i=0; i<nHorItems; i++) {
		angListB.push(botLineRot);
	}
	// le bord  gauche
	var angListL = new Array ();
	for (var i=0; i<nVerItems; i++) {
		angListL.push(lftLineRot);
	}
	
	// les paramtres des positions de tous les lments des coins 
	// le coin en haut,  gauche
	var posListTL = new Array ();
	for (var i=nItems-1; i>-1; i--) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (oRad-(mRad*xPos))-(objW/2);
		var yPos = Math.sin(curVal);
		y = (oRad-(mRad*yPos))-(objW/2);
		posListTL.push([x,y]);
	}
	// le coin en haut,  droite
	var posListTR = new Array ();
	for (var i=0; i<nItems; i++) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (frmW-(oRad-(mRad*xPos)))-(objW/2);
		var yPos = Math.sin(curVal);
		y = (oRad-(mRad*yPos))-(objW/2);
		posListTR.push([x,y]);
	}
	// le coin en bas,  droite
	var posListBR = new Array ();
	for (var i=nItems-1; i>-1; i--) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (frmW-(oRad-(mRad*xPos)))-(objW/2);
		var yPos = Math.sin(curVal);
		y = (frmH-(oRad-(mRad*yPos)))-(objW/2);
		posListBR.push([x,y]);
	}
	// le coin en bas,  gauche
	var posListBL = new Array ();
	for (var i=0; i<nItems; i++) {
		var curVal = (angListBE[i]/360)*(2*pi);
		var xPos = Math.cos(curVal);
		x = (oRad-(mRad*xPos))-(objW/2);
		var yPos = Math.sin(curVal);
		y = (frmH-(oRad-(mRad*yPos)))-(objW/2);
		posListBL.push([x,y]);
	}
	
	// les paramtres des positions de tous les lments des droites
	// le bord en haut
	var posListT = new Array ();
	var curVal = oRad-(objW/2);
	posListT.push([curVal, 0]);
	// le bord droit
	var posListR = new Array ();
	var curVal = oRad-(objW/2);
	posListR.push([frmW-objW, curVal]);
	// le bord en bas
	var posListB = new Array ();
	var curVal = (frmW-oRad)-(objW/2);
	posListB.push([curVal, frmH-objW]);
	// le bord  gauche
	var posListL = new Array ();
	var curVal = (frmH-oRad)-(objW/2);
	posListL.push([0, curVal]);
	
	// la liste des tous les paramtres des positions
	var allPosList = posListTL.concat(posListT, posListTR, posListR, posListBR, posListB, posListBL, posListL);
	
	// la liste des tous les angles
	var allAngList = angListTL.concat(angListT, angListTR, angListR, angListBR, angListB, angListBL, angListL);
	
	// lorsque les angles dsirs sont identiques, adapter la liste des angles
	if ((topLineRot == rgtLineRot) && (topLineRot == botLineRot) && (topLineRot == lftLineRot)) {
		var nVals = allAngList.length;
		for (var i=0; i<nVals; i++) {
			allAngList[i] = topLineRot;
		}
	}
	
	// mettre l'objet de base dans la liste du futur groupe
	groupObjects.push(curFrame);
	// dupliquer l'objet selon le nombre dsir
	if (versNum == 7) {
		curFrame.name = "0_";
		for (var i=0; i<nAllItems-1; i++) {
			curFrame = curFrame.duplicate(undefined, [0, 0]);
			curFrame.name = "" + (i+1) + "_";
			groupObjects.push(curFrame);
		}
	}
	else {
		curFrame.label = "0_";
		for (var i=0; i<nAllItems-1; i++) {
			curFrame = curFrame.duplicate(undefined, [0, 0]);
			curFrame.label = "" + (i+1) + "_";
			groupObjects.push(curFrame);
		}
	}
	
	// dplacer les objets  tour de rle  leurs positions 
	// et appliquer la valeur de l'angle de rotation
	for (var i=0; i<nAllItems; i++) {
		curDoc.pageItems.itemByName("" + i + "_").move(allPosList[i], undefined);
		curDoc.pageItems.itemByName("" + i + "_").rotationAngle = (allAngList[i]);
		curDoc.pageItems.itemByName("" + i + "_").move(undefined, [x1, y1]);
		if (versNum == 7) {
			curDoc.pageItems.itemByName("" + i + "_").name = "";
		}
		else {
			curDoc.pageItems.itemByName("" + i + "_").label = "";
		}
	}
}
////////////////////////////// la fonction "perfectCircle"  (la fin)  ////////////////////////////////////////

////////////////////////////// la fonction "roundedOne"  (le dbut)  /////////////////////////////////////////
// la fonction pour dupliquer l'objet avec un lment coin pivot et dplac
function roundedOne() {
	// ---------- prparer les valeurs ----------
	topLineRot =    0;
	rgtLineRot =  -90;
	botLineRot = -180;
	lftLineRot = -270;
	
	// mettre l'objet de base dans la liste du futur groupe
	groupObjects.push(curFrame);
	
	offVal  = (objW*1)+dVal;  // de l'espace latral supplementaire pour les lments des coins (en units de distance)
	moveVal = (objW/3.5);     // le facteur avec lequel la valeur de dcalage par dfaut (= largeur divis par 3.5) est multiplie
	
	// appliquer l'angle de rotation pour le bord en haut
	curFrame.rotationAngle = topLineRot;
	// l'espace pour les lments horizontaux
	var xRoom = frmW-(offVal*2);
	// le nombre des lments horizontaux
	if (dVal > 0) {
		var nItemsHor = (Math.floor(xRoom/(objW+dVal)))+1;
	}
	else {
		var nItemsHor = Math.floor(xRoom/objW);
	}
	// ... et calculer le dcalage
	var rstSpce = xRoom-(nItemsHor*objW);
	var xOffset = (rstSpce/(nItemsHor-1))+objW;
	// l'espace pour les lments verticaux
	var yRoom = frmH-(offVal*2);
	// le nombre des lments verticaux...
	if (dVal > 0) {
		var nItemsVer = (Math.floor(yRoom/(objW+dVal)))+1;
	}
	else {
		var nItemsVer = Math.floor(yRoom/objW);
	}
	// ... et calculer le dcalage
	var rstSpce = yRoom-(nItemsVer*objW);
	var yOffset = (rstSpce/(nItemsVer-1))+objW;
	
	// ---------- les quatre bords ----------
	// le bord suprieur (de gauche  droite)
	if (versNum == 7) {
		curFrame.name = "one";
	}
	else {
		curFrame.label = "one";
	}
	curFrame = curFrame.duplicate();
	curFrame.move(undefined, [offVal, 0]);
	if (versNum == 7) {
		curFrame.name = "";
	}
	else {
		curFrame.label = "";
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [xOffset, 0]);
		groupObjects.push(curFrame);
	}
	curFrame = curFrame.duplicate(undefined, [0, 0]);
	curFrame.move([x1+(frmW-objW), y1], undefined);
	if (versNum == 7) {
		curFrame.name = "two";
	}
	else {
		curFrame.label = "two";
	}
	groupObjects.push(curFrame);
	// le bord droit (du haut vers le bas)
	curFrame = curFrame.duplicate();
	curFrame.move(undefined, [0, offVal]);
	if (versNum == 7) {
		curFrame.name = "";
	}
	else {
		curFrame.label = "";
	}
	curFrame.rotationAngle = rgtLineRot;
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, yOffset]);
		groupObjects.push(curFrame);
	}
	// le bord infrieur (de la droite vers la gauche)
	curFrame = curFrame.duplicate(undefined, [0, 0]);
	curFrame.move([x1+frmW, y1+(frmH-objW)], undefined);
	curFrame.rotationAngle = botLineRot;
	if (versNum == 7) {
		curFrame.name = "thr";
	}
	else {
		curFrame.label = "thr";
	}
	groupObjects.push(curFrame);
	curFrame = curFrame.duplicate();
	curFrame.move(undefined, [-offVal, 0]);
	if (versNum == 7) {
		curFrame.name = "";
	}
	else {
		curFrame.label = "";
	}
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsHor; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [-xOffset, 0]);
		groupObjects.push(curFrame);
	}
	curFrame = curFrame.duplicate(undefined, [0, 0]);
	curFrame.move([x1+objW, y1+frmH], undefined);
	if (versNum == 7) {
		curFrame.name = "for";
	}
	else {
		curFrame.label = "for";
	}
	groupObjects.push(curFrame);
	// le bord gauche (du bas vers le haut)
	curFrame = curFrame.duplicate();
	curFrame.move(undefined, [0, -offVal]);
	if (versNum == 7) {
		curFrame.name = "";
	}
	else {
		curFrame.label = "";
	}
	curFrame.rotationAngle = lftLineRot;
	groupObjects.push(curFrame);
	for (var i=1; i<nItemsVer; i++) {
		curFrame = curFrame.duplicate();
		curFrame.move(undefined, [0, -yOffset]);
		groupObjects.push(curFrame);
	}
}
////////////////////////////// la fonction "roundedOne"  (la fin)  ///////////////////////////////////////////

////////////////////////////// la fonction "rotateObj"  (le dbut)  //////////////////////////////////////////
// la fonction pour pivoter les lments des coins
function rotateObj() {
	// lorsque les angles sont identiques, appliquer la mme valeur  chaque coin
	if ((topLineRot == rgtLineRot) && (topLineRot == botLineRot) && (topLineRot == lftLineRot)) {
		curDoc.pageItems.itemByName("one").rotationAngle = topLineRot;
		curDoc.pageItems.itemByName("two").rotationAngle = topLineRot;
		curDoc.pageItems.itemByName("thr").rotationAngle = topLineRot;
		curDoc.pageItems.itemByName("for").rotationAngle = topLineRot;
	}
	else { 
		curDoc.pageItems.itemByName("one").rotationAngle = lftLineRot-45;
		curDoc.pageItems.itemByName("two").rotationAngle = topLineRot-45;
		curDoc.pageItems.itemByName("thr").rotationAngle = rgtLineRot-45;
		curDoc.pageItems.itemByName("for").rotationAngle = botLineRot-45;
	}
}
////////////////////////////// la fonction "rotateObj"  (la fin)  ////////////////////////////////////////////

////////////////////////////// la fonction "moveObj"  (le dbut)  ////////////////////////////////////////////
// la fonction pour dcaler les lments des coins
function moveObj() {
	curDoc.pageItems.itemByName("one").move(undefined, [moveVal, moveVal]);
	curDoc.pageItems.itemByName("two").move(undefined, [-moveVal, moveVal]);
	curDoc.pageItems.itemByName("thr").move(undefined, [-moveVal, -moveVal]);
	curDoc.pageItems.itemByName("for").move(undefined, [moveVal, -moveVal]);
	if (versNum == 7) {
		curDoc.pageItems.itemByName("one").name = "";
		curDoc.pageItems.itemByName("two").name = "";
		curDoc.pageItems.itemByName("thr").name = "";
		curDoc.pageItems.itemByName("for").name = "";
	}
	else {
		curDoc.pageItems.itemByName("one").label = "";
		curDoc.pageItems.itemByName("two").label = "";
		curDoc.pageItems.itemByName("thr").label = "";
		curDoc.pageItems.itemByName("for").label = "";
	}
}
////////////////////////////// la fonction "moveObj"  (la fin)  //////////////////////////////////////////////

////////////////////////////// la fonction "groupObj"  (le dbut)  ///////////////////////////////////////////
// la fonction pour grouper les objets du cadre
function groupObj(groupObjects) {
	var newGroup = app.activeWindow.activeSpread.groups.add(groupObjects);
	return newGroup;
}
////////////////////////////// la fonction "groupObj"  (la fin)  /////////////////////////////////////////////

////////////////////////////// la fonction "restorePrefs"  (le dbut)  ///////////////////////////////////////
// die la fonction pour restaurer les prfrences
function restorePrefs() {
	// mettre le point zro  zro/zro (si ncessaire) 
	if (zP != [0,0]) { 
		curDoc.zeroPoint = zP; 
	}
	
	// restaurer le point de rfrence (si ncessaire)
	if (trp != 1095656308) {
		app.layoutWindows[0].transformReferencePoint = trp;
	}
	
	// restaurer les units de mesure (si ncessaire)
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	}
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = vM;
	}
}
////////////////////////////// la fonction "restorePrefs"  (la fin)  /////////////////////////////////////////